#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=RecursiveFileList.ico
#AutoIt3Wrapper_outfile=RecursiveFileList.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Allow_Decompile=n
#AutoIt3Wrapper_Res_Description=RecursiveFileList
#AutoIt3Wrapper_Res_Fileversion=1.5.0.1
#AutoIt3Wrapper_Res_LegalCopyright=Oscar for AutoIt.de
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_AU3Check_Stop_OnWarning=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region Include
#Include <GUIConstants.au3>
#Include <File.au3>
#Include <Misc.au3>
#Include <GUIListView.au3>
#Include <WindowsConstants.au3>
#Include <StaticConstants.au3>
#Include <GUIStatusBar.au3>
#Include <Array.au3>
#EndRegion Include

#Region Opt
Opt('GUICloseOnESC', 0)
Opt('MustDeclareVars', 1)
Opt('TrayAutoPause', 0)
Opt('TrayMenuMode', 1)
Opt('TrayOnEventMode', 1)
Opt('GUIOnEventMode', 1)
#EndRegion Opt

#Region Variable
Global $title = 'Recursive FileList  v1.5'
Global $version = 'Recursive FileList' & @CRLF & 'Version: 1.5.0.1' & @CRLF & 'Datum: 15.02.2008' & @CRLF & @CRLF & '(c)  by Thomas Stephan' & @CRLF & 'E-Mail: Oscar@Elektronik-Kurs.de'
Global $Byte, $Bytes, $aBytes[1], $bBytes, $GAttr, $GDate, $GTimer, $GTimerCheck = False
Global $Files, $count, $msg, $res, $unit, $start, $diff1, $diff2, $FIndex, $StatusOld, $x, $GUI_Beep
Global $aFileList[1], $dirs, $fontsize, $aListview[1][3], $GUI_FileInfo_FAtt[4], $aFileDel[1]
Global $Debug_LV = FALSE
Global $IEversion = StringLeft(RegRead('HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Internet Explorer', 'Version'), 1)
Global $TBarPos = WinGetPos('[CLASS:Shell_TrayWnd]')
Global $fpath = IniRead(@ScriptDir & '\RecursiveFileList.ini', 'Options', 'fpath', 'C:\')
#EndRegion Variable

#Region Check
If (@AutoItVersion < '3.2.10.0') and (Not @Compiled) Then Exit MsgBox(48, $title, 'Dieses Script bentigt Version: 3.2.10.0 ' & @CRLF & @CRLF & 'Gestartet wurde es mit Version: ' & @AutoItVersion)

If _Singleton($title, 1) = 0 Then
	MsgBox(48, $title, 'Das Programm luft bereits!')
	Exit
EndIf

Global $aButtonIcon[12] = ['Beep','BeepNo','Copy','CopyNo','Delete','DeleteNo','Folder','Info','Save','SaveNo','Search','SearchNo']
For $x = 0 To 11
	$aButtonIcon[$x] = @ScriptDir & '\Icons\' & $aButtonIcon[$x] & '.ico'
	If Not FileExists($aButtonIcon[$x]) Then
		MsgBox(16, $title, 'Das Icon "' & $aButtonIcon[$x] & '"  fehlt!')
		Exit
	EndIF
Next

Global $BeepOkSound = @WindowsDir & '\Media\notify.wav'
If Not FileExists($BeepOkSound) Then $BeepOkSound = ''
Global $BeepErrorSound = @WindowsDir & '\Media\chord.wav'
If Not FileExists($BeepErrorSound) Then $BeepErrorSound = ''
#EndRegion Check

#Region Main-GUI
Global $GUI = GUICreate($title, @DesktopWidth, @DesktopHeight, 0, 0, BitOr($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX, $WS_MAXIMIZE))
GUISetIcon(@SystemDir & '\shell32.dll', -172)
GUISetOnEvent($GUI_EVENT_CLOSE, '_SpecialEvents')
GUISetOnEvent($GUI_EVENT_MINIMIZE, '_SpecialEvents')
GUISetOnEvent($GUI_EVENT_RESTORE, '_SpecialEvents')

Global $TMenu_Info = TrayCreateItem('Programm-Infos')
TrayItemSetOnEvent(-1, '_Info')
TrayCreateItem('')
Global $TMenu_Choice = TrayCreateItem('Ordner auswhlen...')
TrayItemSetOnEvent(-1, '_Start')
Global $TMenu_List = TrayCreateMenu('Bearbeiten')
TrayItemSetState(-1, $TRAY_DISABLE)
Global $TMenu_List_MCopy = TrayCreateItem('Kopieren', $TMenu_List)
TrayItemSetOnEvent(-1, '_ListviewCopy')
Global $TMenu_List_MCopy = TrayCreateItem('Lschen', $TMenu_List)
TrayItemSetOnEvent(-1, '_FileRecycle')
TrayCreateItem('', $TMenu_List)
Global $TMenu_List_Copy = TrayCreateItem('Gesamte Liste kopieren', $TMenu_List)
TrayItemSetOnEvent(-1, '_FileListCopy')
Global $TMenu_List_Save = TrayCreateItem('Gesamte Liste speichern...', $TMenu_List)
TrayItemSetOnEvent(-1, '_FileListSave')
Global $TMenu_Search = TrayCreateItem('Suchen...')
TrayItemSetState(-1, $TRAY_DISABLE)
TrayItemSetOnEvent(-1, '_Search')
TrayCreateItem('')
Global $TMenu_Beep = TrayCreateItem('Beep, wenn fertig')
TrayItemSetOnEvent(-1, '_BeepChange')
TrayCreateItem('')
Global $TMenuExit = TrayCreateItem('Beenden')
TrayItemSetOnEvent(-1, '_End')

TraySetIcon(@SystemDir & '\shell32.dll', -172)
TraySetState()

Global $Menu = GUICtrlCreateMenu('Datei')
Global $Menu_Open = GUICtrlCreateMenuItem('Ordner auswhlen...', $Menu)
GUICtrlSetOnEvent(-1, '_Start')
GUICtrlCreateMenuItem('', $Menu)
Global $Menu_End = GUICtrlCreateMenuItem('Programm beenden', $Menu)
GUICtrlSetOnEvent(-1, '_End')
Global $Menu_List = GUICtrlCreateMenu('Bearbeiten')
GUICtrlSetState(-1, $GUI_DISABLE)
Global $Menu_List_MSave = GUICtrlCreateMenuItem('Kopieren', $Menu_List)
GUICtrlSetOnEvent(-1, '_ListviewCopy')
Global $Menu_List_MSave = GUICtrlCreateMenuItem('Lschen', $Menu_List)
GUICtrlSetOnEvent(-1, '_FileRecycle')
GUICtrlCreateMenuItem('', $Menu_List)
Global $Menu_List_Copy = GUICtrlCreateMenuItem('Gesamte Liste kopieren', $Menu_List)
GUICtrlSetOnEvent(-1, '_FileListCopy')
Global $Menu_List_Save = GUICtrlCreateMenuItem('Gesamte Liste speichern...', $Menu_List)
GUICtrlSetOnEvent(-1, '_FileListSave')
Global $Menu_Search = GUICtrlCreateMenu('Suchen')
GUICtrlSetState(-1, $GUI_DISABLE)
Global $Menu_Search_Start = GUICtrlCreateMenuItem('Suchen...', $Menu_Search)
GUICtrlSetOnEvent(-1, '_Search')
Global $Menu_Opt = GUICtrlCreateMenu('Optionen')
Global $Menu_Opt_Beep = GUICtrlCreateMenuItem('Beep, wenn fertig', $Menu_Opt)
GUICtrlSetOnEvent(-1, '_BeepChange')
Global $Menu_Info = GUICtrlCreateMenu('?')
Global $Menu_Info_Info = GUICtrlCreateMenuItem('Programm-Infos', $Menu_Info)
GUICtrlSetOnEvent(-1, '_Info')

Global $GUI_Button_Open = GUICtrlCreateButton('', 10, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_Start')
GUICtrlSetImage(-1, @ScriptDir & '\Icons\Folder.ico', -1, 1)
GUICtrlSetTip(-1, 'Ordner auswhlen...')
GUICtrlSetCursor(-1, 0)
Global $GUI_Button_Save = GUICtrlCreateButton('', 104, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_FileListSave')
GUICtrlSetImage(-1, @ScriptDir & '\Icons\SaveNo.ico')
GUICtrlSetTip(-1, 'Gesamte Liste speichern...')
GUICtrlSetCursor(-1, 7)
Global $GUI_Button_Copy = GUICtrlCreateButton('', 198, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_FileListCopy')
GUICtrlSetImage(-1, @ScriptDir & '\Icons\CopyNo.ico')
GUICtrlSetTip(-1, 'Gesamte Liste in die Zwischenablage kopieren')
GUICtrlSetCursor(-1, 7)
Global $GUI_Button_Delete = GUICtrlCreateButton('', 292, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_FileRecycle')
GUICtrlSetImage(-1, @ScriptDir & '\Icons\DeleteNo.ico')
GUICtrlSetTip(-1, 'Datei/en lschen')
GUICtrlSetCursor(-1, 7)
Global $GUI_Button_Search = GUICtrlCreateButton('', 386, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_Search')
GUICtrlSetImage(-1, @ScriptDir & '\Icons\SearchNo.ico')
GUICtrlSetTip(-1, 'Suchen...')
GUICtrlSetCursor(-1, 7)
Global $GUI_Button_Beep = GUICtrlCreateButton('', 480, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_BeepChange')
GUICtrlSetTip(-1, 'Beep ein-/ausschalten')
GUICtrlSetCursor(-1, 0)
Global $GUI_Button_Info = GUICtrlCreateButton('', 574, 0, 96, 64, $BS_ICON, $WS_EX_STATICEDGE)
GUICtrlSetOnEvent(-1, '_Info')
GUICtrlSetImage(-1, @ScriptDir & '\Icons\Info.ico')
GUICtrlSetTip(-1, 'Programm-Infos')
GUICtrlSetCursor(-1, 0)
GUICtrlCreateLabel('', 0, 62, @DesktopWidth, 3, $SS_SUNKEN)

If Execute(IniRead(@ScriptDir & '\RecursiveFileList.ini', 'Options', 'Beep', True)) = True Then
	$GUI_Beep = True
	GUICtrlSetState($Menu_Opt_Beep, $GUI_CHECKED)
	GUICtrlSetImage($GUI_Button_Beep, @ScriptDir & '\Icons\Beep.ico')
	TrayItemSetState($TMenu_Beep, $TRAY_CHECKED)
Else
	$GUI_Beep = False
	GUICtrlSetState($Menu_Opt_Beep, $GUI_UNCHECKED)
	GUICtrlSetImage($GUI_Button_Beep, @ScriptDir & '\Icons\BeepNo.ico')
	TrayItemSetState($TMenu_Beep, $TRAY_UNCHECKED)
EndIf

GUICtrlCreateGraphic(10, 68, @DesktopWidth-20, 32, $SS_BLACKFRAME)
GUICtrlSetGraphic(-1,$GUI_GR_RECT, 1, 1, @DesktopWidth-22, 30)
GUICtrlSetBKColor(-1, 0xcccccc)
Global $GUI_Head = GUICtrlCreateInput('', 12, 70, @DesktopWidth-24, 28, $ES_READONLY)
GUICtrlSetFont(-1, 16, 400, 0, 'Times New Roman')
GUICtrlSetBKColor(-1, 0xcccccc)

Global $GUI_Listview = GUICtrlCreateListView('|||', 10, 105, @DesktopWidth-20, @DesktopHeight-$TBarPos[3]-180, BitOr($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER))
GUICtrlSetState(-1, $GUI_FOCUS)
GUICtrlSetBKColor(-1, 0xffffff)
GUICtrlSetFont(-1, 10, 400, 0, 'Courier New')
_GUICtrlListView_SetColumn(GUICtrlGetHandle($GUI_Listview), 0, 'Datei-Nr. ', 120, 1)
_GUICtrlListView_SetColumn(GUICtrlGetHandle($GUI_Listview), 1, 'Gre (Bytes) ', 180, 1)
_GUICtrlListView_SetColumn(GUICtrlGetHandle($GUI_Listview), 2, ' Dateiname inkl. Pfad', @DesktopWidth-20, 0)

Global $GUI_LWContextMenu = GUICtrlCreateContextMenu($GUI_Listview)
Global $GUI_LWContextCopy = GUICtrlCreateMenuItem('Kopieren', $GUI_LWContextMenu)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_ListviewCopy')
Global $GUI_LWContextDelete = GUICtrlCreateMenuItem('Lschen', $GUI_LWContextMenu)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_FileRecycle')
GUICtrlCreateMenuItem('', $GUI_LWContextMenu)
Global $GUI_LWContextInfo = GUICtrlCreateMenuItem('Eigenschaften', $GUI_LWContextMenu)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_FileInfo')

GUICtrlCreateLabel('', 0, @DesktopHeight-$TBarPos[3]-51, @DesktopWidth, 3, $SS_SUNKEN)
Global $GUI_Status = _GUICtrlStatusBar_Create($GUI, -1, '   Fertig.')

GUISetState(@SW_SHOW, $GUI)
_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
#EndRegion Main-GUI

#Region GUI_FileInfo
Global $GUI_FileInfo = GUICreate('Datei-Informationen', 320, 450, -1, -1, $WS_SYSMENU, -1, $GUI)
GUISetIcon(@SystemDir & '\shell32.dll', -222)
GUISetOnEvent($GUI_EVENT_CLOSE, '_GUI_FileInfoClose')
Global $GUI_FileInfo_Tab = GUICtrlCreateTab(5, 5, 305, 370)
Global $GUI_FileInfo_TabI = GUICtrlCreateTabitem('Eigenschaften')
GUICtrlCreateLabel('Dateiname', 20, 40, 280, 20)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $InputStyle = BitOr($ES_READONLY, $ES_LEFT, $ES_AUTOHSCROLL)
Global $GUI_FileInfo_FName = GUICtrlCreateInput('', 15, 60, 280, 20, $InputStyle)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')

GUICtrlCreateLabel('Pfad', 20, 95, 280, 20)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $GUI_FileInfo_FPath = GUICtrlCreateInput('', 15, 115, 280, 20, $InputStyle)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')

GUICtrlCreateLabel('Dateigre', 20, 150, 280, 20)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $GUI_FileInfo_FSize = GUICtrlCreateInput('', 15, 170, 280, 20, $InputStyle)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')

GUICtrlCreateGroup('Dateidatum (erstellt am:)', 15, 215, 280, 55)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $GUI_FileInfo_FDate = GUICtrlCreateDate('', 25, 235, 145, 25, $DTS_SHORTDATEFORMAT)
GUICtrlSetOnEvent(-1, '_Change1')
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $GUI_FileInfo_FTime = GUICtrlCreateDate('', 195, 235, 90, 25, $DTS_TIMEFORMAT)
GUICtrlSetOnEvent(-1, '_Change1')
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Dateiattribute', 15, 285, 280, 75)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $aAtt[4] = ['Schreibgeschtzt','Archiviert','Versteckt','Systemdatei']
For $x = 0 To 1
	$GUI_FileInfo_FAtt[$x] = GUICtrlCreateCheckBox($aAtt[$x], 40, 305 + $x * 25, 100, 20)
	GUICtrlSetOnEvent(-1, '_Change2')
	$GUI_FileInfo_FAtt[$x+2] = GUICtrlCreateCheckBox($aAtt[$x+2], 175, 305 + $x * 25, 100, 20)
	GUICtrlSetOnEvent(-1, '_Change2')
Next
GUICtrlSetState($GUI_FileInfo_FAtt[3], $GUI_DISABLE)
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $GUI_FileInfo_Ok = GUICtrlCreateButton('Ok', 75, 385, 70, 23)
GUICtrlSetOnEvent(-1, '_Ok')
Global $GUI_FileInfo_Cancel = GUICtrlCreateButton('Abbrechen', 155, 385, 70, 23)
GUICtrlSetOnEvent(-1, '_GUI_FileInfoClose')
Global $GUI_FileInfo_Accept = GUICtrlCreateButton('bernehmen', 235, 385, 70, 23)
GUICtrlSetOnEvent(-1, '_Accept')
GUICtrlSetState(-1, $GUI_DISABLE)
#EndRegion GUI_FileInfo

#Region GUI_Search
Global $GUI_Search = GUICreate('Suchen...', 320, 240, -1, -1, $WS_SYSMENU, -1, $GUI)
GUISetIcon(@SystemDir & '\shell32.dll', -23)
GUISetOnEvent($GUI_EVENT_CLOSE, '_GUI_SearchClose')

GUICtrlCreateGraphic(10, 10, 290, 150, $SS_SUNKEN )
GUICtrlSetGraphic(-1,$GUI_GR_RECT, 1, 1, 288, 148)
GUICtrlSetBKColor(-1, 0xbbbbbb)

GUICtrlCreateGroup('Suchbegriff', 20, 20, 270, 60)
GUICtrlSetBKColor(-1, 0xbbbbbb)
Global $GUI_Search_Input = GUICtrlCreateInput('', 30, 45, 250, 25)
GUICtrlSetOnEvent(-1, '_SearchOk')
GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
Global $GUI_Search_CaseSen = GUICtrlCreateCheckbox('Gro-/Kleinschreibung beachten', 35, 100, 250, 20)
GUICtrlSetBKColor(-1, 0xbbbbbb)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $GUI_Search_OnlyFName = GUICtrlCreateCheckbox('Nur im Dateinamen (ohne Pfad) suchen', 35, 130, 250, 20)
GUICtrlSetBKColor(-1, 0xbbbbbb)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $GUI_Search_Ok = GUICtrlCreateButton('Suchen...', 150, 175, 70, 23, $BS_DEFPUSHBUTTON)
GUICtrlSetOnEvent(-1, '_SearchOk')
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
Global $GUI_Search_Cancel = GUICtrlCreateButton('Abbrechen', 230, 175, 70, 23)
GUICtrlSetOnEvent(-1, '_GUI_SearchClose')
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
#EndRegion GUI_Search

#Region GUI_Info
Global $GUI_Info = GUICreate('Programm-Informationen', 320, 240, -1, -1, BitOr($WS_CLIPSIBLINGS,$WS_SYSMENU), -1, $GUI)
GUISetIcon(@SystemDir & '\shell32.dll', -222)
GUISetOnEvent($GUI_EVENT_CLOSE, '_GUI_InfoClose')
GUICtrlCreateGraphic(10, 10, 290, 150, $SS_SUNKEN)
GUICtrlSetGraphic(-1,$GUI_GR_RECT, 1, 1, 287, 147)
GUICtrlCreateIcon(@ScriptDir & '\Icons\Info.ico', -1, 20, 20, 48, 48)
Global $versionHead = StringMid($version, 1, StringInStr($version, @CRLF)-1)
Global $versionBody = StringMid($version, StringInStr($version, @CRLF)+1)
GUICtrlCreateLabel($versionHead, 85, 20, 200, 20)
GUICtrlSetFont(-1, 12, 600, 0, 'Arial')
GUICtrlCreateLabel($versionBody, 85, 40, 200, 100)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $GUI_Info_Ok = GUICtrlCreateButton('Ok', 130, 175, 60, 23, $BS_DEFPUSHBUTTON)
GUICtrlSetOnEvent(-1, '_GUI_InfoClose')
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
#EndRegion GUI_Info

#Region GUI_Recycle
Global $GUI_Recycle = GUICreate('Datei/en in den Papierkorb', 420, 480, -1, -1, BitOr($WS_CLIPSIBLINGS,$WS_SYSMENU), -1, $GUI)
GUISetIcon(@SystemDir & '\shell32.dll', -33)
GUISetOnEvent($GUI_EVENT_CLOSE, '_GUI_RecycleClose')
GUICtrlCreateGraphic(10, 10, 393, 390, $SS_SUNKEN)
GUICtrlSetGraphic(-1,$GUI_GR_RECT, 1, 1, 390, 387)
GUICtrlCreateIcon(@ScriptDir & '\Icons\Delete.ico', -1, 20, 20, 48, 48)
GUICtrlCreateLabel('Sollen diese Dateien wirklich in den Papierkorb verschoben werden?', 85, 30, 300, 40)
GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
Global $GUI_Recycle_Edit = GUICtrlCreateEdit('', 20, 80, 370, 300)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
Global $GUI_Recycle_Yes = GUICtrlCreateButton('Ja', 250, 415, 70, 23)
GUICtrlSetOnEvent(-1, '_GUI_RecycleYes')
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
Global $GUI_Recycle_No = GUICtrlCreateButton('Nein', 333, 415, 70, 23, $BS_DEFPUSHBUTTON)
GUICtrlSetOnEvent(-1, '_GUI_RecycleClose')
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
#EndRegion GUI_Recycle

#Region WaitLoop
While 1
	Sleep(10)
	If $GTimerCheck Then
		If TimerDiff($GTimer) > 3000 Then
			$GTimerCheck = False
			_GUICtrlStatusBar_SetText($GUI_Status, $StatusOld)
			_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
		EndIf
	EndIf
WEnd
#EndRegion WaitLoop

#Region Functions GUI_Recycle
Func _GUI_RecycleClose()
	GUISetState(@SW_HIDE, $GUI_Recycle)
	GUISetState(@SW_ENABLE, $GUI)
	_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
EndFunc

Func _GUI_RecycleYes()
	Local $r, $i, $cnt = 0
	For $i = $aFileDel[0] To 1 Step -1
		$r = FileRecycle(StringMid($aListview[$aFileDel[$i]][2], 2))
		If $r Then _GUICtrlListView_DeleteItem(GUICtrlGetHandle($GUI_Listview), $aFileDel[$i])
		$cnt += $r
	Next
	If $cnt = $aFileDel[0] Then
		_BeepOk()
		_GUICtrlStatusBar_SetText($GUI_Status, '   Die Dateien wurden komplett in den Papierkorb verschoben!')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
	Else
		_BeepError()
		_GUICtrlStatusBar_SetText($GUI_Status, '   Die Dateien konnten nicht komplett in den Papierkorb verschoben werden!')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 53, @SystemDir & '\shell32.dll')
	EndIf
	GUISetState(@SW_HIDE, $GUI_Recycle)
	GUISetState(@SW_ENABLE, $GUI)
EndFunc
#EndRegion Functions GUI_Recycle

#Region Functions GUI_Info
Func _GUI_InfoClose()
	GUISetState(@SW_HIDE, $GUI_Info)
	GUISetState(@SW_ENABLE, $GUI)
	_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
EndFunc
#EndRegion Functions GUI_Info

#Region Functions GUI_Search
Func _GUI_SearchClose()
	GUISetState(@SW_HIDE, $GUI_Search)
	GUISetState(@SW_ENABLE, $GUI)
	_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
EndFunc

Func _SearchOk()
	Local $find, $cs, $ofn, $pos, $val, $i, $cnt = 0
	$cs = BitAnd(GUICtrlRead($GUI_Search_CaseSen), $GUI_CHECKED)
	$ofn = BitAnd(GUICtrlRead($GUI_Search_OnlyFName), $GUI_CHECKED)
	$find = GUICtrlRead($GUI_Search_Input)
	If $find <> '' Then
		ControlListView($title, '', $GUI_Listview, 'SelectClear')
		For $i = 0 To $count-1
			$pos = StringInStr($aListview[$i][2], '\', 0, 1-$ofn*2)
			$val = StringMid($aListview[$i][2], $pos+1)
			If StringInStr($val, $find, $cs) > 0 Then
				_GUICtrlListView_SetItemSelected($GUI_Listview, $i, True)
				$cnt += 1
			EndIf
		Next
		GUICtrlSetState($GUI_Search_Ok, $GUI_DEFBUTTON)
		GUICtrlSetState($GUI_Search_Input, $GUI_FOCUS)
		Switch $cnt
			Case 0
				_BeepError()
				_GUICtrlStatusBar_SetText($GUI_Status, '   Es wurden keine Dateien gefunden!')
				_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 53, @SystemDir & '\shell32.dll')
			Case 1
				_BeepOk()
				_GUICtrlStatusBar_SetText($GUI_Status, '   Es wurde 1 Datei gefunden!')
				_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
			Case Else
				_BeepOk()
				_GUICtrlStatusBar_SetText($GUI_Status, '   Es wurden ' & $cnt & ' Dateien gefunden!')
				_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
		EndSwitch
	Else
		_GUICtrlStatusBar_SetText($GUI_Status, '   Fertig.')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
	EndIf
EndFunc
#EndRegion Function GUI_Search

#Region Functions GUI_FileInfo
Func _FileInfo()
	GUICtrlSetState($GUI_FileInfo_Accept, $GUI_DISABLE)
	Local $file, $pos, $t, $d, $att, $Fatt
	$FIndex = _GUICtrlListView_GetSelectionMark($GUI_Listview)
	$GDate = False
	$GAttr = False
	If $FIndex <> -1 Then
		$file = StringMid($aListview[$FIndex][2], 2)
		$pos = StringInStr($file, '\', 0, -1)
		GUICtrlSetData($GUI_FileInfo_FName, StringMid($file, $pos+1))
		GUICtrlSetData($GUI_FileInfo_FPath, StringLeft($file, $pos))
		GUICtrlSetData($GUI_FileInfo_FSize, _KMGBytes($aBytes[$FIndex]) & ' (' & $aListview[$FIndex][1] & ' Bytes)')
		$t = FileGetTime($file, 1, 1)
		$d = StringMid($t, 1, 4) & '/' & StringMid($t, 5, 2) & '/' & StringMid($t, 7, 2)
		$t = $d & ' ' & StringMid($t, 9, 2) & ':' & StringMid($t, 11, 2) & ':' & StringMid($t, 13, 2)
		GUICtrlSetData($GUI_FileInfo_FDate, $d)
		GUICtrlSetData($GUI_FileInfo_FTime, $t)
		$att = FileGetAttrib($file)
		For $i = 0 To 3
			If StringInStr($att, StringMid('RAHS', $i+1, 1)) = 0 Then
				GUICtrlSetState($GUI_FileInfo_FAtt[$i], $GUI_UNCHECKED)
			Else
				GUICtrlSetState($GUI_FileInfo_FAtt[$i], $GUI_CHECKED)
			EndIf
		Next
		GUISetState(@SW_SHOW, $GUI_FileInfo)
		GUISetState(@SW_DISABLE, $GUI)
	EndIf
EndFunc

Func _GUI_FileInfoClose()
	GUISetState(@SW_HIDE, $GUI_FileInfo)
	GUISetState(@SW_ENABLE, $GUI)
EndFunc

Func _Change1()
	$GDate = True
	GUICtrlSetState($GUI_FileInfo_Accept, $GUI_ENABLE)
EndFunc

Func _Change2()
	$GAttr = True
	GUICtrlSetState($GUI_FileInfo_Accept, $GUI_ENABLE)
EndFunc

Func _Ok()
	If BitAnd(GUICtrlGetState($GUI_FileInfo_Accept), $GUI_ENABLE) Then _Accept()
	_GUI_FileInfoClose()
EndFunc

Func _Accept()
	Local $c = 0, $r = False, $d, $t, $atp = '', $atm = ''
	If $GDate Then
		$d = StringSplit(GUICtrlRead($GUI_FileInfo_FDate), '.')
		$d = $d[3] & $d[2] & $d[1]
		$t = StringReplace(GUICtrlRead($GUI_FileInfo_FTime), ':', '')
		If StringInStr(FileGetAttrib(StringMid($aListview[$FIndex][2], 2)), 'R') > 0 Then
			_BeepError()
			If MsgBox(4, $title, 'Die Datei ist schreibgeschtzt!' & @CRLF & 'Sollen Datum und Uhrzeit trotzdem gendert werden?') = 6 Then
				FileSetAttrib(StringMid($aListview[$FIndex][2], 2), '-R')
				$r = True
			EndIf
		EndIf
		If StringInStr(FileGetAttrib(StringMid($aListview[$FIndex][2], 2)), 'R') = 0 Then
			For $i = 0 To 2
				$c += FileSetTime(StringMid($aListview[$FIndex][2], 2), $d & $t, $i)
			Next
			If $c < 3 Then
				_BeepError()
				MsgBox(48, $title, 'Konnte Datum/Uhrzeit nicht schreiben!')
				GUICtrlSetState($GUI_FileInfo_Accept, $GUI_ENABLE)
			Else
				GUICtrlSetState($GUI_FileInfo_Accept, $GUI_DISABLE)
				$GDate = False
			EndIf
		EndIf
		If $r Then FileSetAttrib(StringMid($aListview[$FIndex][2], 2), '+R')
	EndIf
	If $GAttr Then
		For $i = 0 To 2
			If BitAnd(GUICtrlRead($GUI_FileInfo_FAtt[$i]), $GUI_CHECKED) Then
				$atp &= StringMid('RAH', $i+1, 1)
			Else
				$atm &= StringMid('RAH', $i+1, 1)
			EndIf
		Next
		If $atp <> '' Then $atp = '+' & $atp
		If $atm <> '' Then $atm = '-' & $atm
		If FileSetAttrib(StringMid($aListview[$FIndex][2], 2), $atp & $atm) = 0 Then 
			_BeepError()
			MsgBox(48, $title, 'Konnte Attribute nicht setzen!')
			GUICtrlSetState($GUI_FileInfo_Accept, $GUI_ENABLE)
		Else
			GUICtrlSetState($GUI_FileInfo_Accept, $GUI_DISABLE)
			$GAttr = False
		EndIf
	EndIf
EndFunc
#EndRegion Functions GUI_FileInfo

#Region Functions Main-GUI
Func _SpecialEvents()
	Switch @GUI_CTRLID
		Case $GUI_EVENT_CLOSE
			_End()
		Case $GUI_EVENT_MINIMIZE
			GUISetState(@SW_MINIMIZE, $GUI)
		Case $GUI_EVENT_RESTORE
			GUISetState(@SW_RESTORE, $GUI)
			GUISetState(@SW_MAXIMIZE, $GUI)
	EndSwitch
EndFunc

Func _End()
	IniWrite(@ScriptDir & '\RecursiveFileList.ini', 'Options', 'Beep', $GUI_Beep)
	IniWrite(@ScriptDir & '\RecursiveFileList.ini', 'Options', 'fpath', $fpath)
	Exit
EndFunc

Func _FileRecycle()
	Local $msg = ''
	$aFileDel = _GUICtrlListView_GetSelectedIndices($GUI_Listview, True)
	$StatusOld = _GUICtrlStatusBar_GetText($GUI_Status, 0)
	If $aFileDel[0] > 0 Then
		For $i = 1 To $aFileDel[0]
			$msg &= StringMid($aListview[$aFileDel[$i]][2], 2) & @CRLF
		Next
		GUICtrlSetData($GUI_Recycle_Edit, $msg)
		GUISetState(@SW_DISABLE, $GUI)
		GUISetState(@SW_SHOW, $GUI_Recycle)
	EndIf
EndFunc

Func _FileListSave()
	If $count > 0 Then
		Local $i, $msg
		Local $sfile = FileSaveDialog($title, @DesktopDir & '\', '(*.txt)', 16, 'Dateiliste.txt')
		If Not @error Then
			$StatusOld = _GUICtrlStatusBar_GetText($GUI_Status, 0)
			Local $hsfile = FileOpen($sfile, 2+8)
			If $hsfile = -1 Then
				_BeepError()
				_GUICtrlStatusBar_SetText($GUI_Status, '   Die Datei konnte nicht erstellt werden!')
				_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 53, @SystemDir & '\shell32.dll')
				$GTimer = TimerInit()
				$GTimerCheck = True
				Return 1
			Else
				For $i = 0 To $count-1
					$msg = StringRight('       ' & $aListview[$i][0], 7) & Chr(9)
					$msg &= StringRight('                  ' & $aListview[$i][1], 16) & Chr(9)
					$msg &= $aListview[$i][2]
					If FileWriteLine($hsfile, $msg) = 0 Then
						_BeepError()
						_GUICtrlStatusBar_SetText($GUI_Status, '   Das speichern der Liste ist fehlgeschlagen!')
						_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 53, @SystemDir & '\shell32.dll')
						$GTimer = TimerInit()
						$GTimerCheck = True
						FileClose($hsfile)
						Return 1
					EndIf
				Next
				FileClose($hsfile)
				_BeepOk()
				_GUICtrlStatusBar_SetText($GUI_Status, '   Die Liste wurde erfolgreich gespeichert!')
				_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
				$GTimer = TimerInit()
				$GTimerCheck = True
			EndIf
		EndIf
	EndIf
EndFunc

Func _FileListCopy()
	If $count > 0 Then
		Local $i, $msg = ''
		$StatusOld = _GUICtrlStatusBar_GetText($GUI_Status, 0)
		For $i = 0 To $count-1
			$msg &= StringRight('       ' & $aListview[$i][0], 7) & Chr(9)
			$msg &= StringRight('                  ' & $aListview[$i][1], 16) & Chr(9)
			$msg &= $aListview[$i][2] & @CRLF
		Next
		ClipPut($msg)
		_BeepOk()
		_GUICtrlStatusBar_SetText($GUI_Status, '   Die Liste wurde erfolgreich in die Zwischenablage kopiert!')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
		$GTimer = TimerInit()
		$GTimerCheck = True
	EndIf
EndFunc

Func _Search()
	If $count > 0 Then
		GUISetState(@SW_DISABLE, $GUI)
		GUISetState(@SW_SHOW, $GUI_Search)
		GUICtrlSetState($GUI_Search_Ok, $GUI_DEFBUTTON)
		GUICtrlSetState($GUI_Search_Input, $GUI_FOCUS)
	EndIF
EndFunc

Func _Info()
	GUISetState(@SW_SHOW, $GUI_Info)
	GUISetState(@SW_DISABLE, $GUI)
EndFunc

Func _BeepChange()
	Switch $GUI_Beep
		Case True
			GUICtrlSetState($Menu_Opt_Beep, $GUI_UNCHECKED)
			GUICtrlSetImage($GUI_Button_Beep, @ScriptDir & '\Icons\BeepNo.ico')
			TrayItemSetState($TMenu_Beep, $TRAY_UNCHECKED)
		Case False
			GUICtrlSetState($Menu_Opt_Beep, $GUI_CHECKED)
			GUICtrlSetImage($GUI_Button_Beep, @ScriptDir & '\Icons\Beep.ico')
			TrayItemSetState($TMenu_Beep, $TRAY_CHECKED)
	EndSwitch
	$GUI_Beep = Not $GUI_Beep
EndFunc

Func _BeepOk()
	If $GUI_Beep Then
		If $BeepOkSound <> '' Then
			SoundPlay($BeepOkSound)
		Else
			Beep(1200, 50)
		EndIf
	EndIf
EndFunc

Func _BeepError()
	If $GUI_Beep Then
		If $BeepErrorSound <> '' Then
			SoundPlay($BeepErrorSound)
		Else
			Beep(200, 150)
		EndIf
	EndIf
EndFunc

Func _ListviewCopy()
	Local $aArray = _GUICtrlListView_GetSelectedIndices($GUI_Listview, True), $msg = ''
	$StatusOld = _GUICtrlStatusBar_GetText($GUI_Status, 0)
	If $aArray[0] > 0 Then
		For $i = 1 To $aArray[0]
			$msg &= StringMid($aListview[$aArray[$i]][2], 2) & @CRLF
		Next
		ClipPut($msg)
		_BeepOk()
		_GUICtrlStatusBar_SetText($GUI_Status, '   Die Daten wurden in die Zwischenablage kopiert!')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
		$GTimer = TimerInit()
		$GTimerCheck = True
	Else
		_BeepError()
		_GUICtrlStatusBar_SetText($GUI_Status, '   Keine Daten zum kopieren gefunden!')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 53, @SystemDir & '\shell32.dll')
		$GTimer = TimerInit()
		$GTimerCheck = True
	EndIf
EndFunc

Func _Start()
	Local $hpath = $fpath
	$Files = ''
	$Bytes = ''
	$msg = ''
	$fpath = FileSelectFolder('Bitte ein Laufwerk oder Verzeichnis auswhlen, das durchsucht werden soll!', '', 2*($IEversion > 4), $fpath)
	If Not @error Then
		$start = TimerInit()
		GUISetCursor(15, 1, $GUI)
		If StringRight($fpath, 1) <> '\' Then $fpath &= '\'
		GUICtrlSetData($GUI_Head, ' Pfad = "' & $fpath & '"     ')
		_GUICtrlStatusBar_SetText($GUI_Status, '   Dateiliste wird eingelesen! Bitte warten...')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 55, @SystemDir & '\shell32.dll')
		_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($GUI_Listview))
		Local $aSize	= DirGetSize($fpath, 1)
		If $aSize[1] > 0 Then
			ReDim $aBytes[$aSize[1]], $aListview[$aSize[1]][3]
			$count = 0
			$dirs = 1
			$bBytes = 0
			_FileListToString($fpath)
			$diff1 = Round(TimerDiff($start) / 1000, 3)
			$start = TimerInit()
			_GUICtrlStatusBar_SetText($GUI_Status, '   (Lesezugriff= ' & $diff1 & ' sek.)   Anzeige wird vorbereitet!     Bitte warten...')
			_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
			_GUICtrlListView_SetItemCount(GUICtrlGetHandle($GUI_Listview), $aSize[1]+1)
			$res = ' Pfad = "' & $fpath & '"     ' & xStringAddComma($count, '.', ',') & ' Dateien in '
			$res &= $dirs & StringTrimRight(' Verzeichnissen', 3*($dirs = 1)) & '   '
			$res &= _KMGBytes($bBytes) & '  (' &xStringAddComma($bBytes, '.', ',') & ' Bytes)' 
			GUICtrlSetData($GUI_Head, $res)
			_GUICtrlListView_AddArray($GUI_Listview, $aListview)
			_GUICtrlListView_SetColumnWidth(GUICtrlGetHandle($GUI_Listview), 2, $LVSCW_AUTOSIZE_USEHEADER)
			GUICtrlSetState($GUI_LWContextCopy, $GUI_ENABLE)
			GUICtrlSetState($GUI_LWContextDelete, $GUI_ENABLE)
			GUICtrlSetState($GUI_LWContextInfo, $GUI_ENABLE)
			GUICtrlSetState($Menu_List, $GUI_ENABLE)
			GUICtrlSetState($Menu_Search, $GUI_ENABLE)
			GUICtrlSetImage($GUI_Button_Save, @ScriptDir & '\Icons\Save.ico')
			GUICtrlSetImage($GUI_Button_Copy, @ScriptDir & '\Icons\Copy.ico')
			GUICtrlSetImage($GUI_Button_Delete, @ScriptDir & '\Icons\Delete.ico')
			GUICtrlSetImage($GUI_Button_Search, @ScriptDir & '\Icons\Search.ico')
			GUICtrlSetCursor($GUI_Button_Save, 0)
			GUICtrlSetCursor($GUI_Button_Copy, 0)
			GUICtrlSetCursor($GUI_Button_Delete, 0)
			GUICtrlSetCursor($GUI_Button_Search, 0)
			TrayItemSetState($TMenu_List, $TRAY_ENABLE)
			TrayItemSetState($TMenu_Search, $TRAY_ENABLE)
		Else
			GUICtrlSetState($GUI_LWContextCopy, $GUI_DISABLE)
			GUICtrlSetState($GUI_LWContextDelete, $GUI_DISABLE)
			GUICtrlSetState($GUI_LWContextInfo, $GUI_DISABLE)
			GUICtrlSetState($Menu_List, $GUI_DISABLE)
			GUICtrlSetState($Menu_Search, $GUI_DISABLE)
			GUICtrlSetImage($GUI_Button_Save, @ScriptDir & '\Icons\SaveNo.ico')
			GUICtrlSetImage($GUI_Button_Copy, @ScriptDir & '\Icons\CopyNo.ico')
			GUICtrlSetImage($GUI_Button_Delete, @ScriptDir & '\Icons\DeleteNo.ico')
			GUICtrlSetImage($GUI_Button_Search, @ScriptDir & '\Icons\SearchNo.ico')
			GUICtrlSetCursor($GUI_Button_Save, 0)
			GUICtrlSetCursor($GUI_Button_Copy, 0)
			GUICtrlSetCursor($GUI_Button_Delete, 0)
			GUICtrlSetCursor($GUI_Button_Search, 0)
			TrayItemSetState($TMenu_List, $TRAY_DISABLE)
			TrayItemSetState($TMenu_Search, $TRAY_DISABLE)
		EndIf
		GUISetCursor(2, 1, $GUI)
		_BeepOk()
		$diff2 = Round(TimerDiff($start) / 1000, 3)
		_GUICtrlStatusBar_SetText($GUI_Status, '   Fertig.    (Lesezugriff= ' & $diff1 & ' sek.  +  Anzeige= ' & $diff2 & ' sek.)')
		_GUICtrlStatusBar_SetIcon($GUI_Status, 0, 110, @SystemDir & '\shell32.dll')
	Else
		$fpath = $hpath
	EndIf
EndFunc

Func _KMGBytes($lBytes)
	Local $unit = ' KB ', $kmg = 0
	Select
		Case ($lBytes / 2^30) > 1
			$kmg = Round($lBytes / 2^30, 2)
			$unit = ' GB '
		Case ($lBytes / 2^20) > 1
			$kmg = Round($lBytes / 2^20, 2)
			$unit = ' MB '
		Case ($lBytes / 2^10) > 1
			$kmg = Round($lBytes / 2^10, 2)
			$unit = ' KB '
	EndSelect
	Return xStringAddComma($kmg, '.', ',') & $unit
EndFunc

Func _FileListToString($path)
	Local $hSearch, $sFile, $lBytes
	$hSearch = FileFindFirstFile($path & '*.*')
	If $hSearch <> -1 Then
		While 1
			$sFile = FileFindNextFile($hSearch)
			If @error Then
				SetError(0)
				ExitLoop
			EndIf
			If StringInStr(FileGetAttrib($path & $sFile), 'D') <> 0 Then ContinueLoop
			$aListview[$count][0] = xStringAddComma($count+1) & '  '
			$aBytes[$count] = FileGetSize($path & $sFile)
			$aListview[$count][1] = xStringAddComma($aBytes[$count]) & ' '
			$aListview[$count][2] = ' ' & $path & $sFile
			$bBytes += $aBytes[$count]
			$count += 1
		WEnd
		FileClose($hSearch)
	EndIf
	_ReFileListToString($path)
EndFunc

Func _ReFileListToString($path)
	_GUICtrlStatusBar_SetText($GUI_Status, '   ' & $path)
	Local $dFileList = _FileListToArray($path, '*', 2), $lBytes
	If IsArray($dFileList) Then
		$dirs += $dFileList[0]
		For $i = 1 To $dFileList[0]
			Local $hSearch, $sFile
			$hSearch = FileFindFirstFile($path & $dFileList[$i] & '\' & '*.*')
			If $hSearch <> -1 Then
				While 1
					$sFile = FileFindNextFile($hSearch)
					If @error Then
						SetError(0)
						ExitLoop
					EndIf
					If StringInStr(FileGetAttrib($path & $dFileList[$i] & '\' & $sFile), 'D') <> 0 Then ContinueLoop
					$aBytes[$count] = FileGetSize($path & $dFileList[$i] & '\' & $sFile)
					$aListview[$count][0] = xStringAddComma($count+1) & '  '
					$aListview[$count][1] = xStringAddComma($aBytes[$count]) & ' '
					$aListview[$count][2] = ' ' & $path & $dFileList[$i] & "\" & $sFile
					$bBytes += $aBytes[$count]
					$count += 1
				WEnd
				FileClose($hSearch)
			EndIf
			_ReFileListToString($path & $dFileList[$i] & '\')
		Next
	EndIf
EndFunc

Func xStringAddComma($sStr, $sSeparator = '.', $sEnd = ',')
	Local $aNum = StringSplit($sStr, '.,'), $l = StringLen($aNum[1]), $r = ''
	If $aNum[0] > 2 Then Return SetError(1, 0, $sStr)
	Switch $l
		Case 0 To 3
			Return StringRegExpReplace($sStr, '[.,]', $sEnd)
		Case Else
			For $i = 1 To Int($l / 3)
				$r = $sSeparator & StringRight($aNum[1], 3) & $r
				$aNum[1] = StringTrimRight($aNum[1], 3)
			Next
			$r = StringTrimLeft($aNum[1] & $r, $aNum[1] = '')
			If $aNum[0] > 1 Then $r &= $sEnd & $aNum[2]
			Return $r
	EndSwitch
EndFunc
#EndRegion Functions Main-GUI
